/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { DependencyProperty } from "igniteui-angular-core";
import { runOn, markType, markDep } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { PathGeometry } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-angular-core";
import { Numeric } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let PolarSplineAreaSeries = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeries extends PolarLineSeriesBase {
        constructor() {
            super();
            this.ab = PolarSplineAreaSeries.$;
        }
        bk() {
            return new PolarSplineAreaSeries();
        }
        z8() {
            return false;
        }
        get_ew() {
            return true;
        }
        get_f1() {
            return true;
        }
        ct() {
            return new PolarSplineAreaSeriesView(this);
        }
        q7(a) {
            super.q7(a);
            this.ac4 = a;
        }
        ac2(a) {
            let b = a;
            b.dn();
        }
        ac3(a, b) {
            this.ac2(b);
            if (a.n.count < 1) {
                return;
            }
            let c = b;
            c.dp(a.n, this.ac5);
            this.zf.az(this, this.z7(), runOn(this, this.yx));
            let d = false;
            let e = this.zf.b;
            if (e != null) {
                d = true;
            }
            if (d) {
                this.abm(-1, this.zt.count, b.t);
            }
            let f = c.dv;
            let g = c.du;
            this.zf.ad(f, true, false, true, true);
            this.zf.ad(g, false, true, false, false);
            g._opacity = this.zf.j * this.ia;
        }
        get_acz() {
            return true;
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case PolarSplineAreaSeries.$$p[0]:
                    this.ry(false);
                    break;
            }
        }
    }
    PolarSplineAreaSeries.$t = markType(PolarSplineAreaSeries, 'PolarSplineAreaSeries', PolarLineSeriesBase.$);
    PolarSplineAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineAreaSeries, 'raisePropertyChanged', ['Stiffness:ac5:ac7', [1, 0.5]]);
    return PolarSplineAreaSeries;
})();
/**
 * @hidden
 */
export let PolarSplineAreaSeriesView = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesView extends PolarLineSeriesBaseView {
        constructor(a) {
            super(a);
            this.dm = null;
            this.dt = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.ds = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.dr = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.dq = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.dm = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.dm.xk = Defaults.e;
            }
        }
        get du() {
            return this.ds;
        }
        get dv() {
            return this.dt;
        }
        dn() {
            Extensions.e(this.ds.an);
            Extensions.e(this.dt.an);
            Extensions.e(this.dq.an);
            Extensions.e(this.dr.an);
            this.a2();
        }
        dp(a, b) {
            this.dt.an.c = Numeric.h(a.count + 1, (c) => c < a.count ? a._inner[c].x : a._inner[c - a.count].x, (c) => c < a.count ? a._inner[c].y : a._inner[c - a.count].y, b);
            this.ds.an.c = Numeric.h(a.count + 1, (c) => c < a.count ? a._inner[c].x : a._inner[c - a.count].x, (c) => c < a.count ? a._inner[c].y : a._inner[c - a.count].y, b);
            this.a2();
        }
        bp() {
            super.bp();
        }
        bq() {
            super.bq();
            let a = this.b3();
            this.dq.an = this.ds.an;
            this.dr.an = this.dt.an;
            this.dq._fill = a;
            this.dq._opacity = 1;
            this.dr._stroke = a;
            this.dr.ad = this.f.ig + 3;
        }
        bj(a, b) {
            super.bj(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.dq);
                    a.t(this.dr);
                }
                else {
                    a.t(this.ds);
                    a.t(this.dt);
                }
            }
        }
        ax(a) {
            super.ax(a);
            this.f.bc.exportPathData(a, this.dt, "polarShape", ["Main"]);
            this.f.bc.exportPathData(a, this.ds, "fillShape", ["Fill"]);
        }
        an() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.f.wb = a;
            this.f.jq = 5;
            this.f.jr = 5;
            this.f.js = 5;
        }
    }
    PolarSplineAreaSeriesView.$t = markType(PolarSplineAreaSeriesView, 'PolarSplineAreaSeriesView', PolarLineSeriesBaseView.$);
    return PolarSplineAreaSeriesView;
})();
